package com.zhongzheng.modules.user.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.user.bo.UserStudyRecordAddBo;
import com.zhongzheng.modules.user.bo.UserStudyRecordEditBo;
import com.zhongzheng.modules.user.bo.UserStudyRecordQueryBo;
import com.zhongzheng.modules.user.domain.UserStudyRecord;
import com.zhongzheng.modules.user.vo.UserStudyRecordVo;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * 用户学习记录Service接口
 *
 * @author ruoyi
 * @date 2021-06-25
 */
public interface IUserStudyRecordService extends IService<UserStudyRecord> {
	/**
	 * 查询单个
	 * @return
	 */
	UserStudyRecordVo queryById(Long recordId);

	/**
	 * 查询列表
	 */
	List<UserStudyRecordVo> queryList(UserStudyRecordQueryBo bo);

	List<UserStudyRecordVo> selectList(UserStudyRecordQueryBo bo);

	/**
	 * 根据新增业务对象插入用户学习记录
	 * @param bo 用户学习记录新增业务对象
	 * @return
	 */
	Integer insertByAddBo(UserStudyRecordAddBo bo);

	/**
	 * 根据编辑业务对象修改用户学习记录
	 * @param bo 用户学习记录编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserStudyRecordEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    List<UserStudyRecord> selectUserStudy(Long userId, Integer courseId);
}
